//
//  ViewController.m
//  LabelDemo
//
//  Copyright (c) 2012 Shuichi Tsutsumi. All rights reserved.
//

#import "ViewController.h"



@interface ViewController ()
<TTTAttributedLabelDelegate>
@property (nonatomic, retain) IBOutlet OHAttributedLabel *ohLabel;
@property (nonatomic, retain) IBOutlet TTTAttributedLabel *tttLabel;
@property (nonatomic, strong) NSURL *linkUrl;
@end


@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    NSString *linkStr = @"iOSアプリ開発に役立つTips";
    NSString *strongStr = @"いいね！";
    NSString *txt = [NSString stringWithFormat:@"『%@』というFacebookページをつくりました。iOSアプリ開発に役立つTipsをお届けしているので、ぜひ%@をお願いします！", linkStr, strongStr];
    self.linkUrl = [NSURL URLWithString:@"http://www.facebook.com/iOSDevTips"];

    NSRange linkRange = [txt rangeOfString:linkStr];
    NSRange strongRange = [txt rangeOfString:strongStr];

    UIFont *baseFont = [UIFont systemFontOfSize:16];
    UIFont *boldFont = [UIFont boldSystemFontOfSize:17];

    UIColor *strongColor = [UIColor colorWithRed:1.0f green:0.f blue:0.f alpha:1.f];
    
    
    // ---- OHAttributedLabel ----
    
    NSMutableAttributedString* attrStr = [NSMutableAttributedString attributedStringWithString:txt];
    
    // ベースの設定
    [attrStr setFont:baseFont];
    [attrStr setTextColor:[UIColor grayColor]];
    
    // 文字色
    [attrStr setTextColor:strongColor range:strongRange];
    
    // Bold
//    [attrStr setTextBold:YES range:strongRange];
    [attrStr setFont:boldFont range:strongRange];
    
    // リンク
    [attrStr setLink:self.linkUrl range:linkRange];
    
    self.ohLabel.attributedText = attrStr;
    
    
    
    
    
    // ---- TTTAttributedLabel ----
    
    [self.tttLabel setText:txt afterInheritingLabelAttributesAndConfiguringWithBlock:
     ^NSMutableAttributedString *(NSMutableAttributedString *attrStr) {
         
         // ベースの設定
         [attrStr setFont:baseFont];
         [attrStr setTextColor:[UIColor grayColor]];

         // 文字色
         [attrStr setTextColor:strongColor range:strongRange];

         // Bold
         [attrStr setFont:boldFont range:strongRange];

         return attrStr;
     }];
    
    // リンク
    [self.tttLabel addLinkToURL:self.linkUrl withRange:linkRange];
    self.tttLabel.delegate = self;
    
    self.tttLabel.verticalAlignment = TTTAttributedLabelVerticalAlignmentTop;
}




#pragma mark -------------------------------------------------------------------
#pragma mark TTTAttributedLabelDelegate

- (void)attributedLabel:(TTTAttributedLabel *)label didSelectLinkWithURL:(NSURL *)url {
    
    [[UIApplication sharedApplication] openURL:self.linkUrl];
}

@end
